from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String, File, Int

Anvi_Run_Pfams_V0_1_0 = CommandToolBuilder(tool="anvi_run_pfams", base_command=["anvi-run-pfams"], inputs=[ToolInput(tag="in_contigs_db", input_type=String(optional=True), prefix="--contigs-db", doc=InputDocumentation(doc="Anvi'o contigs database generated by 'anvi-gen-\ncontigs-database' (default: None)")), ToolInput(tag="in_pfam_data_dir", input_type=File(optional=True), prefix="--pfam-data-dir", doc=InputDocumentation(doc="The directory path for your Pfam setup. Anvi'o will\ntry to use the default path if you do not specify\nanything. (default: None)")), ToolInput(tag="in_num_threads", input_type=Int(optional=True), prefix="--num-threads", doc=InputDocumentation(doc="Maximum number of threads to use for multithreading\nwhenever possible. Very conservatively, the default is\n1. It is a good idea to not exceed the number of CPUs\n/ cores on your system. Plus, please be careful with\nthis option if you are running your commands on a SGE\n--if you are clusterizing your runs, and asking for\nmultiple threads to use, you may deplete your\nresources very fast. (default: 1)")), ToolInput(tag="in_hmmer_program", input_type=Int(optional=True), prefix="--hmmer-program", doc=InputDocumentation(doc="Which of the HMMER programs to use to run HMMs\n(hmmscan or hmmsearch). By default anvi'o will use\nhmmscan for typical HMM operations like those in anvi-\nrun-hmms (as these tend to scan a very large number of\ngenes against a relatively small number of HMMs), but\nif you are using this program to scan a very large\nnumber of HMMs, hmmsearch might be a better choice for\nperformance. For this reason, hmmsearch is the default\nin operations like anvi-run-pfams and anvi-run-kegg-\nkofams. See this article for a discussion on the\nperformance of these two programs:\nhttps://cryptogenomicon.org/2011/05/27/hmmscan-vs-\nhmmsearch-speed-the-numerology/ (default: None)")), ToolInput(tag="in_functions", input_type=String(), position=0, doc=InputDocumentation(doc="🍺 More on `anvi-run-pfams`:"))], outputs=[], container="quay.io/biocontainers/anvio-minimal:7--py_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Anvi_Run_Pfams_V0_1_0().translate("wdl")

